/******************************************************************************
	[App.h]
		AvP[ṼC^tFCX`܂D

	Copyright (C) 2004 Ki

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
******************************************************************************/
#ifndef APP_H_INCLUDED
#define APP_H_INCLUDED

#include "TypeDefs.h"

#define	APP_CONFIG_FILENAME	"Ootake.dat" //KitaoXV


BOOL
APP_Init(
	int		argc,
	char**	argv);

Sint32
APP_ProcessEvents();

BOOL
APP_Deinit(
	int		argc,
	char**	argv);


enum AppEvent
{
	APP_IDLE,
	APP_QUIT,
	APP_TOGGLE_FULLSCREEN,
	APP_RESET,
	APP_SHOWMENU,
	APP_HIDEMENU,
	APP_MENUACTIVE,
	APP_OPENGAME,
	APP_SAVESTATE,
	APP_LOADSTATE,

	APP_SAMPLERATE11025,
	APP_SAMPLERATE22050,
	APP_SAMPLERATE32000,
	APP_SAMPLERATE44100,
	APP_SAMPLERATE48000,

	APP_OVERSAMPLERATE_1,
	APP_OVERSAMPLERATE_2,
	APP_OVERSAMPLERATE_4,
	APP_OVERSAMPLERATE_8,
	APP_OVERSAMPLERATE_16,
	APP_OVERSAMPLERATE_32,

	APP_SOUNDBUFFER_256,
	APP_SOUNDBUFFER_512,
	APP_SOUNDBUFFER_1024,
	APP_SOUNDBUFFER_2048,
	APP_SOUNDBUFFER_4096,

	APP_FPS_30,
	APP_FPS_60,
	APP_FPS_120,

	APP_WAIT_VSYNC,

	APP_SCREEN_X1,
	APP_SCREEN_X2,
	APP_SCREEN_X3,
	APP_SCREEN_X4,
};


//Kitaoǉ
void
APP_RunEmulator(
	BOOL		bRun);

//Kitaoǉ
BOOL
APP_CheckCDGame();

//KitaoǉBEBhËʒuۑBWinMain.cgpB
void
APP_SaveWindowPosition();

//KitaoǉBV-Syncj[Enable܂͊DFɁB
void
APP_EnableVSyncMenu(
	BOOL screen60hz);

//KitaoǉBj[\ǂԂ
BOOL
APP_GetbRunning();

//KitaoǉBAvP[V(Ootake)̃pXԂB
char*
APP_GetAppPath();

//KitaoǉBgpCDhCũio[ԂB0ȂPځB1ȂQځB
Sint32
APP_GetCurrentCdDrive();

//KitaoǉBPSG̃{[ԂB
Uint32
APP_GetPsgVolume();

//KitaoǉBADPCM̃{[ԂB
Uint32
APP_GetAdpcmVolume();

//KitaoǉBCD̃{[ԂB
Uint32
APP_GetCdVolume();

//KitaoǉB_bStretched,_bVStretchedݒ肷BMainBorad.cXe[g[hɎgpB
void
APP_SetStretched(
	BOOL	bStretched,
	BOOL	bVStretched
);

//KitaoǉBWinMain.cgp
void
APP_TurboCycleMenu();

//Kitaoǉ
void
APP_SaveBRAM();

//Kitaoǉ
Sint32
APP_GetRenshaSpeed();

//Kitaoǉ
void
APP_EndRecording();

//Kitaoǉ
void
APP_EndPlayback();

//Kitaoǉ
BOOL
APP_GetFullScreen();

//Kitaoǉ
BOOL
APP_GetHideMessage();

//Kitaoǉ
BOOL
APP_GetFullHideMessage();

//Kitaoǉ
BOOL
APP_GetDefaultFastCD();

//Kitaoǉ
BOOL
APP_GetDefaultFastSeek();

//Kitaoǉ
BOOL
APP_GetDefaultSpriteLimit();

//Kitaoǉ
inline Sint32
APP_GetScanLineType();

//Kitaoǉ
void
APP_SetInputConfiguration();

//Kitaoǉ
char*
APP_GetGameFileNameBuf();


#endif // APP_H_INCLUDED
